/*
    FEARLUS model0-5-1-5: VarProbeWidget2.m
    Copyright (C) 1999-2004  Macaulay Institute

    This file is part of FEARLUS model0-5-1-5, an agent-based model of land use
    change.

    FEARLUS model0-5-1-5 is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FEARLUS model0-5-1-5 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details. (LICENCE file in
    this directory.)

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact information:
      Gary Polhill,
      Macaulay Institute, Craigiebuckler, Aberdeen, AB15 8QH. United Kingdom
      g.polhill@macaulay.ac.uk
*/
/*


Implementation for the VarProbeWidget2 object. Some of the code is pinched from
Swarm's VarProbeWidget object. See the header file for more info.

*/

#import "VarProbeWidget2.h"

@implementation VarProbeWidget2

+createBegin: aZone {
  id obj = [super createBegin: aZone];
  return obj;
}

-setObject: obj {
  myObject = obj;
  return self;
}

-setProbe: aProbe {
  myProbe = aProbe;
  return self;
}

-setParent: aFrame {
  myParent = aFrame;
  return self;
}

-createEnd {
  [super createEnd];
  myEntry = [VarProbeEntry createBegin: [self getZone]];
  [myEntry setOwner: self];
  [myEntry setParent: myParent];
  interactiveFlag = [myProbe getInteractiveFlag];
  [myEntry setInteractiveFlag: interactiveFlag];
  [myEntry setVarProbe: myProbe];
  myEntry = [myEntry createEnd];

  [self update];
  return self;
}

-Spawn: (const char *)widgetName {
  id target = (*(id *)[myProbe probeRaw: myObject]);

  if (target) {
    CREATE_PROBE_DISPLAY (target);
  }
  else {
    GUI_BEEP ();
    GUI_UPDATE ();
  }
  return self;
}

-pack {
  [myEntry pack];
  return self;
}

-packFillLeft: (BOOL)dunno {
  [myEntry packFillLeft: dunno];
  return self;
}

-(unsigned)getWidth {
  return [myEntry getWidth];
}

-setWidth: (unsigned)aWidth {
  [myEntry setWidth: aWidth];
  return self;
}

-setVariableValue: (const char *)windowName {
  [myProbe setData: myObject ToString: [myEntry getValue]];
  
  return self;
}

-update {
  char buffer[512];
  
  if (interactiveFlag) {
    [myEntry setValue: [myProbe probeAsString: myObject Buffer: buffer]];
  }
  else {
    [myEntry setActiveFlag: YES];
    [myEntry setValue: [myProbe probeAsString: myObject Buffer: buffer]];
    [myEntry setActiveFlag: NO];
  }
    
  GUI_UPDATE ();
  
  return self;
}

-(void)drop {
  [myEntry drop];
  [super drop];
}

-idReceive: (const char *)windowName {
  id resObj = GUI_DRAG_AND_DROP_OBJECT ();
  
  [myProbe setData: myObject To: &resObj]; 
  GUI_FOCUS (self);
  [self update];
  return self;
}

-(const char *)package: (const char *)windowName {
  id *content = [myProbe probeRaw: myObject];

  if (*content == nil) {
    GUI_BEEP ();
    GUI_UPDATE ();
    return "";
  }
  return [*content getObjectName];
}

-(const char *)getId: (const char *)windowName {
  return [myEntry getValue];
}


@end
