/*
    FEARLUS model0-5-1-5: YieldTotalRandomOptimumTemporalCopyingStrategy.h
    Copyright (C) 1999-2002, 2004  Macaulay Institute

    This file is part of FEARLUS model0-5-1-5, an agent-based model of land use
    change.

    FEARLUS model0-5-1-5 is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FEARLUS model0-5-1-5 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details. (LICENCE file in
    this directory.)

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact information:
      Gary Polhill,
      Macaulay Institute, Craigiebuckler, Aberdeen, AB15 8QH. United Kingdom
      g.polhill@macaulay.ac.uk
*/
/*


Interface for the YieldTotalRandomOptimumTemporalCopyingStrategy object. This is
a ridiculously long-named, historical, imitative strategy for determining the
land use of a land parcel. Calculate total yield for each land use on the
land manager's own and neighbours land (a neighbourhood weighting is applied to the
neighbours' land parcels' land uses' yield before adding them to the total). 
Looks back over yields within the memory of the land manager owning the land parcel.
Choose at random among those land uses with the highest score. This strategy assumes the
land managers are prepared to divulge yield information to their neighbours
truthfully. I guess land managers should look up that information between
each other.

*/

#import <objectbase/SwarmObject.h>
#import "Strategy.h"

@interface YieldTotalRandomOptimumTemporalCopyingStrategy: SwarmObject
<ImitativeStrategy, HistoricalStrategy> {
  LandManager *lm;
  Parameter *parameter;
}

@end
